#include <stdlib.mqh>

extern int    Lookback        =   4;
extern bool   WriteToChart    = true;
extern int    NMMPeriod       = 40;
extern int    NMMPrice        = PRICE_CLOSE;
extern int    TEMAPeriod      = 10;
extern bool   Interpolate     = false;

double nmmM1[];
double nmmM5[];
double nmmM15[];
double nmmM30[];
double nmmH1[];
double nmmH4[];
double nmmD1[];
int oldBars;

//
//
//
int init() {
   return(0);
}


//
//
//
int deinit() {

   
   return(0);
}


//
//
//
int start() {
   int j,k;

         if (ArrayRange(nmmH1,0)!=Lookback) ArrayResize(nmmH1,Lookback);
         if (ArrayRange(nmmH4,0)!=Lookback) ArrayResize(nmmH4,Lookback);
         if (ArrayRange(nmmD1,0)!=Lookback) ArrayResize(nmmD1,Lookback);

         for (k=0; k<Lookback; k++)
         {
            nmmH1[k] = iCustom(NULL, 0, "ocn nmm mtf rainbow 1.01", NMMPeriod,NMMPrice,TEMAPeriod,Interpolate, 4, k);
            nmmH4[k] = iCustom(NULL, 0, "ocn nmm mtf rainbow 1.01", NMMPeriod,NMMPrice,TEMAPeriod,Interpolate, 5, k);
            nmmD1[k] = iCustom(NULL, 0, "ocn nmm mtf rainbow 1.01", NMMPeriod,NMMPrice,TEMAPeriod,Interpolate, 6, k);
         }

   if (WriteToChart) subWriteToChart();
   if (oldBars != Bars) oldBars = Bars;
   
return(0);
}



//+------------------------------------------------------------------+

void subWriteToChart()
{

   int i,j;
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";

   sComment = sp;
   sComment = sComment + WindowExpertName()+ "  Balance=" + DoubleToStr(AccountBalance(),0)+ "  Equity=" + DoubleToStr(AccountEquity(),0) + NL;
   sComment = sComment + "Current Server DateTime = " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS) + NL;
   sComment = sComment + NL;
   for (i=0; i<Lookback ; i++)
   {
      sComment = sComment + "  nmmH1[" + i + "] = " + DoubleToStr(nmmH1[i],4) + ", ";
      sComment = sComment + "  nmmH4[" + i + "] = " + DoubleToStr(nmmH4[i],4) + ", ";
      sComment = sComment + "  nmmD1[" + i + "] = " + DoubleToStr(nmmD1[i],4) + NL;
   }   
   sComment = sComment + NL;
   sComment = sComment + sp;
  
  
   Comment(sComment);
}

